export declare const deprecatedFunction: (_: any, property: string) => boolean;
import { Ffi, FfiHandle } from '../../ffi/types';
export declare type FnObject = {
    [key: string]: (...args: any) => any;
};
export declare type FnMapping<T extends FnObject, O> = {
    [Key in keyof T]: FnArgumentMapping<O>;
};
export declare enum FnValidationStatus {
    SUCCESS = 0,
    IGNORE = 1,
    FAIL = 2
}
export declare type FnValidationResult = {
    status: FnValidationStatus;
    messages?: string[];
};
export declare type FnArgumentMapping<O> = {
    validateAndExecute: (ffi: Ffi, handle: FfiHandle, options: O) => FnValidationResult;
};
